///////////////////////////////////////////////////////////////////////////
//  Notes   : Odbiera kody standardu RC5 i SONY, automatycznie rozpoznaje //
//          : rodzaj standardu na podstawie czasu trwania bitu startowego //
//			: dla Sony czas=2,4ms, dla RC5 899us						  //
////////////////////////////////////////////////////////////////////////////

#define IR_IN		portb_0						//definicja pinu odbiornika IR
#define IR_IN_TRIS	trisb_0					//definicja tris odbiornika IR
#define RC5		1
#define Sony	2
int command, address;							//bufor komendy i adresu
int	IR_OK;										//zapisany jest stan

//************************************************************************//
//Procedura sprawdza, czy zostal odebrany nowy kod IR, jesli tak to		  //
//zwraca kod systemu, w ktorym dane sa odebrane 					      //                                                                     //
//************************************************************************//
int get_ir()
{
	return(ir_ok);							    //zwroc stan odbieranego kodu
}
//************************************************************************//


//************************************************************************//
// Inicjalizacja portu do obslugi odbiornika IR		                      //
//************************************************************************//
IR_init()
{	delay_ms(100);
	IR_IN_TRIS=1;								   //port odbiornika jako wejciowy
	IR_OK=0;									      //brak nowej komendy IR
	bit_clear(option_reg,intedg);				//option.6 przerwanie int na zbocze opadajace
	bit_set(intcon, inte);						//wlacza przerwanie external
	bit_set(intcon,gie);						   //wlacza globalne przerwania
	bit_set(intcon, peie);
}
//************************************************************************//


//************************************************************************//
// procedura odbioru danych IR w przerwaniu zewnetrznym		              //
//************************************************************************//
#int_ext
get_ir_int()
{int header,i,j;
 int16 ir_buf;
 boolean b1;
 bit_clear(intcon, inte);						//wylacza przerwanie external

 address=0xff;
 command=0xff;
 header=0;
 while(!IR_IN)									   //sprawdzenie warunku zajmuje 5cykli
 	{delay_us(15);								   //+15u daje 20uS dla X=4MHz
    ++header;
    }
if(header>40&&header<50)						//jesli czas poczatku>800us, i <1ms to RC5
	{for(i=0;i<13;i++)							//jesli odebrano bit startu to odbiera dalsze bity
		{
		b1=IR_IN;								   //kopiuj 1 faze bitu do b1
		j=0;
		while(1)								      //czekanie na zmane stanu
			{
			if(++j>100) goto IR_END;			//jesli bit nie zmienia sie przez ok.1ms to blad
			if(!IR_IN&&b1)						   //jesli byl stan 1, to oczekiwanie na 0, jesli wystapi to bit=1
				{bit_set(IR_buf,0);				//to zapisz do RC5_buf stan 1
				IR_buf<<=1;						   //przesun w lewo
				break;							   //wyjscie z petli while
				}
			else if(IR_IN&&!b1)					//jesli stan byl 0, to oczekiwanie na 1, jesli wystapi, to bit=0
				{bit_clear(IR_BUF,0);			//to zapisz do RC5_buf 0
				IR_buf<<=1;						   //przesun w prawo
				break;							   //wyjscie z petli while
				}

			}
		delay_us(1341);							//poczekaj 3/4bitu, zeby wskoczyc w srodek nastepnego
		}										      //jeden bit=1,788ms
	IR_buf>>=1;									   //przesun w prawo, bo przy zapisie bit jest przesuwany
	command=IR_buf&0b01111111;					//dla nastepnej transmisji
	IR_buf>>=6;									   //zapisz command
	address=IR_buf&0b00011111;					//zapisz addres
	IR_OK=RC5;									   //ustaw znacznik odebrania kodu RC5
	return;
	}
else if(header>100&&header<140)				//jesli czas poczatku>2ms i <2,8ms to SONY
	{for(i=0;i<12;i++)							//sprobuj odebrac 12 bitow
		{header=0;
		while(IR_IN)							   //czekaj na stan niski przez 0,9ms
		 	{if(++header>90)	goto IR_END;	//jesli nie ma to blad i powrot
			}									
		header=0;
		while(!IR_IN)							   //jesli stan niski trwa >1,4ms
		 	{if(++header>140)	goto IR_END;	//to blad i powrot
		 	}								
	//odebrany jeden bit
		if(header>=90) bit_set(IR_buf,15);	//jesli >0,9ms to stan 1, na sony_buf15
		else if(header<80&&header>45)			//jesli>0,45m i <0,8ms to stan 0
	    	 bit_clear(IR_buf,15);				//na sony_buf15
		else goto IR_END;						   //jesli czas inny to blad
		IR_buf>>=1;
		}
		IR_buf>>=3;								   //dosun do prawej
		command=IR_buf&0b01111111;				//komenda do command
		IR_buf>>=7;
		address=IR_buf&0b00011111;				//adres urzadzenia do address
		IR_OK=sony;								   //ustaw znacznik nowego kodu sony
		return;
	}
												      //jesli pierwszy bit nie odpowiada
												      //zadnemu standardowi lub blad to powrot
IR_END:
	IR_OK=0;									      //brak nowego kodu IR
	bit_set(intcon, inte);						//wlacza przerwanie external

}
//************************************************************************//

