////////////////////////////////////////////////////////////////////////////////
// obsluga wyswietlacza LED w przerwaniu od TMR0, kwarc 4MHz
//
//          ___________                      __
//         |        RB7|--[ R ]-- SEGH      |  |
//         |        RB6|--[ R ]-- SEGG      |__|
//         |        RB5|--[ R ]-- SEGF      |  |
//         |        RB4|--[ R ]-- SEGE      |__|
//         |        RB3|--[ R ]-- SEGD
//         |        RB2|--[ R ]-- SEGC
//         |        RB1|--[ R ]-- SEGB
//         |        RB0|--[ R ]-- SEGA
//         |           |
//         |PIC16F87X  |
//         |        RA3|--[ R ]-- T4
//         |        RA2|--[ R ]-- T3
//         |        RA1|--[ R ]-- T2
//         |________RA0|--[ R ]-- T1
//
//
////////////////////////////////////////////////////////////////////////////////

#include <16F877.h>
#use delay(clock=4000000)
#fuses NOWDT,XT, PUT, NOPROTECT, NODEBUG, BROWNOUT, NOLVP, NOCPD, NOWRT

#byte SEG_PORT =0x06                             //adres portu PB
#byte ANO_PORT =0x05                             //adres portu PA

//definicja segmentow wyswietlacza do wyswietlania cyfr
//0,1,2,3,4,5,6,7,8,9
byte const LedC[10]={0b00111111,
                     0b00000110,
                     0b01011011,
                     0b01001111,
                     0b01100110,
				         0b01101101,
                     0b01111101,
                     0b00000111,
                     0b01111111,
                     0b01101111
                  };


int DISP;						                        //numer wyswietlanego wyswietlacza
int DIGIT_BUF[4];						                  //bufor wyswietlanych cyfr


////////////////////////////////////////////////////////////////////////////////
void main()
{int i;
   setup_adc_ports(NO_ANALOGS);
   setup_timer_0(RTCC_INTERNAL|RTCC_DIV_4);        //przerwanie co ~1ms
   enable_interrupts(INT_TIMER0);                  //przerwanie od TMR0 wlaczone
   enable_interrupts(GLOBAL);                      //globalne wlaczone
   output_b(0x00);                                 //segmenty wygaszone
   output_a(0x00);                                 //katody wylaczone
   DISP=0;

   while(1)                                        //wyswietlanie kolejnych cyfr na wszystkich wyswietlaczach
   {
   for(i=0;i<10;i++)
         {DIGIT_BUF[0]=i;
          DIGIT_BUF[1]=i;
          DIGIT_BUF[2]=i;
          DIGIT_BUF[3]=i;
          delay_ms(500);
         }



   }



}
////////////////////////////////////////////////////////////////////////////////




//przerwanie od TMR0
#int_TIMER0
TIMER0_isr()
{
////***********

   ANO_PORT&=0xF0;							 //wylacz wszystkie wyswietlacze
   SEG_PORT=0x00;
   SEG_PORT=LedC[DIGIT_BUF[disp]];		 //wystawia na katody dane dla wysw. podanego w DISP

   switch(DISP)								 //w zaleznosci od numeru wyswietlacza
   	{											 //ustawia stan niski(poprzez tranzystor) na odpowiedniej katodzie
   	case 0: ANO_PORT|=0x01;break;
   	case 1: ANO_PORT|=0x02;break;
   	case 2: ANO_PORT|=0x04;break;
   	case 3: ANO_PORT|=0x08;break;
   	}

   if(++DISP>3)         DISP=0;			 //jesli zwiekszony nr wyswietl. >3 to zeruj
}
